Gentoo Archives: gentoo-commits

From: "Robin H. Johnson (robbat2)" <robbat2@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] gentoo-x86 commit in dev-vcs/git: git-1.7.11.1.ebuild ChangeLog
Date: Sat, 07 Jul 2012 05:30:06
Message-Id: 20120707052955.656952004B@flycatcher.gentoo.org
1 robbat2 12/07/07 05:29:55
2
3 Modified: ChangeLog
4 Added: git-1.7.11.1.ebuild
5 Log:
6 Version bump. Still suffers from bug #391707: git-svn failures.
7
8 (Portage version: 2.2.0_alpha115/cvs/Linux x86_64)
9
10 Revision Changes Path
11 1.141 dev-vcs/git/ChangeLog
12
13 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.141&view=markup
14 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.141&content-type=text/plain
15 diff : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?r1=1.140&r2=1.141
16
17 Index: ChangeLog
18 ===================================================================
19 RCS file: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v
20 retrieving revision 1.140
21 retrieving revision 1.141
22 diff -p -w -b -B -u -u -r1.140 -r1.141
23 --- ChangeLog 3 Jul 2012 19:28:00 -0000 1.140
24 +++ ChangeLog 7 Jul 2012 05:29:55 -0000 1.141
25 @@ -1,6 +1,12 @@
26 # ChangeLog for dev-vcs/git
27 # Copyright 1999-2012 Gentoo Foundation; Distributed under the GPL v2
28 -# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.140 2012/07/03 19:28:00 jer Exp $
29 +# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.141 2012/07/07 05:29:55 robbat2 Exp $
30 +
31 +*git-1.7.11.1 (07 Jul 2012)
32 +
33 + 07 Jul 2012; Robin H. Johnson <robbat2@g.o>
34 + +files/git-1.7.11.1-optional-cvs.patch, +git-1.7.11.1.ebuild:
35 + Version bump. Still suffers from bug #391707: git-svn failures.
36
37 03 Jul 2012; Jeroen Roovers <jer@g.o> git-1.7.8.6.ebuild:
38 Stable for HPPA (bug #418381).
39
40
41
42 1.1 dev-vcs/git/git-1.7.11.1.ebuild
43
44 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-1.7.11.1.ebuild?rev=1.1&view=markup
45 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-1.7.11.1.ebuild?rev=1.1&content-type=text/plain
46
47 Index: git-1.7.11.1.ebuild
48 ===================================================================
49 # Copyright 1999-2012 Gentoo Foundation
50 # Distributed under the terms of the GNU General Public License v2
51 # $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-1.7.11.1.ebuild,v 1.1 2012/07/07 05:29:55 robbat2 Exp $
52
53 EAPI=4
54
55 GENTOO_DEPEND_ON_PERL=no
56
57 # bug #329479: git-remote-testgit is not multiple-version aware
58 PYTHON_DEPEND="python? 2"
59 [[ ${PV} == *9999 ]] && SCM="git-2"
60 EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
61
62 inherit toolchain-funcs eutils elisp-common perl-module bash-completion-r1 python ${SCM}
63
64 MY_PV="${PV/_rc/.rc}"
65 MY_P="${PN}-${MY_PV}"
66
67 DOC_VER=${MY_PV}
68
69 DESCRIPTION="GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team"
70 HOMEPAGE="http://www.git-scm.com/"
71 if [[ ${PV} != *9999 ]]; then
72 SRC_URI_SUFFIX="gz"
73 SRC_URI_GOOG="http://git-core.googlecode.com/files"
74 SRC_URI_KORG="mirror://kernel/software/scm/git"
75 SRC_URI="${SRC_URI_GOOG}/${MY_P}.tar.${SRC_URI_SUFFIX}
76 ${SRC_URI_KORG}/${MY_P}.tar.${SRC_URI_SUFFIX}
77 ${SRC_URI_GOOG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
78 ${SRC_URI_KORG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
79 doc? (
80 ${SRC_URI_KORG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
81 ${SRC_URI_GOOG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
82 )"
83 KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~sparc-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~ia64-hpux ~x86-interix ~amd64-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
84 KEYWORDS="" # Pending git-svn fixes
85 else
86 SRC_URI=""
87 KEYWORDS=""
88 fi
89
90 LICENSE="GPL-2"
91 SLOT="0"
92 IUSE="+blksha1 +curl cgi doc emacs +gpg gtk +iconv +nls +pcre +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion test"
93
94 # Common to both DEPEND and RDEPEND
95 CDEPEND="
96 !blksha1? ( dev-libs/openssl )
97 sys-libs/zlib
98 pcre? ( dev-libs/libpcre )
99 perl? ( dev-lang/perl[-build] )
100 tk? ( dev-lang/tk )
101 curl? (
102 net-misc/curl
103 webdav? ( dev-libs/expat )
104 )
105 emacs? ( virtual/emacs )"
106
107 RDEPEND="${CDEPEND}
108 gpg? ( app-crypt/gnupg )
109 perl? ( dev-perl/Error
110 dev-perl/Net-SMTP-SSL
111 dev-perl/Authen-SASL
112 cgi? ( virtual/perl-CGI app-text/highlight )
113 cvs? ( >=dev-vcs/cvsps-2.1 dev-perl/DBI dev-perl/DBD-SQLite )
114 subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl dev-perl/TermReadKey )
115 )
116 python? ( gtk?
117 (
118 >=dev-python/pygtk-2.8
119 dev-python/pygtksourceview:2
120 ) )"
121
122 # This is how info docs are created with Git:
123 # .txt/asciidoc --(asciidoc)---------> .xml/docbook
124 # .xml/docbook --(docbook2texi.pl)--> .texi
125 # .texi --(makeinfo)---------> .info
126 DEPEND="${CDEPEND}
127 app-arch/cpio
128 doc? (
129 app-text/asciidoc
130 app-text/docbook2X
131 sys-apps/texinfo
132 )
133 test? (
134 app-crypt/gnupg
135 )"
136
137 # Live ebuild builds man pages and HTML docs, additionally
138 if [[ ${PV} == *9999 ]]; then
139 DEPEND="${DEPEND}
140 app-text/asciidoc
141 app-text/xmlto"
142 fi
143
144 SITEFILE=50${PN}-gentoo.el
145 S="${WORKDIR}/${MY_P}"
146
147 REQUIRED_USE="
148 cgi? ( perl )
149 cvs? ( perl )
150 subversion? ( perl )
151 webdav? ( curl )
152 "
153
154 pkg_setup() {
155 if use subversion && has_version dev-vcs/subversion && built_with_use --missing false dev-vcs/subversion dso ; then
156 ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
157 ewarn "with USE=dso, there may be weird crashes in git-svn. You"
158 ewarn "have been warned."
159 fi
160 if use python ; then
161 python_set_active_version 2
162 python_pkg_setup
163 fi
164 }
165
166 # This is needed because for some obscure reasons future calls to make don't
167 # pick up these exports if we export them in src_unpack()
168 exportmakeopts() {
169 local myopts
170
171 if use blksha1 ; then
172 myopts="${myopts} BLK_SHA1=YesPlease"
173 elif use ppcsha1 ; then
174 myopts="${myopts} PPC_SHA1=YesPlease"
175 fi
176
177 if use curl ; then
178 use webdav || myopts="${myopts} NO_EXPAT=YesPlease"
179 else
180 myopts="${myopts} NO_CURL=YesPlease"
181 fi
182
183 # broken assumptions, because of broken build system ...
184 myopts="${myopts} NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
185 myopts="${myopts} INSTALL=install TAR=tar"
186 myopts="${myopts} SHELL_PATH=${EPREFIX}/bin/sh"
187 myopts="${myopts} SANE_TOOL_PATH="
188 myopts="${myopts} OLD_ICONV="
189 myopts="${myopts} NO_EXTERNAL_GREP="
190
191 # can't define this to null, since the entire makefile depends on it
192 sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
193
194 use iconv \
195 || myopts="${myopts} NO_ICONV=YesPlease"
196 use nls \
197 || myopts="${myopts} NO_GETTEXT=YesPlease"
198 use tk \
199 || myopts="${myopts} NO_TCLTK=YesPlease"
200 use pcre \
201 && myopts="${myopts} USE_LIBPCRE=yes"
202 use perl \
203 && myopts="${myopts} INSTALLDIRS=vendor" \
204 || myopts="${myopts} NO_PERL=YesPlease"
205 use python \
206 || myopts="${myopts} NO_PYTHON=YesPlease"
207 use subversion \
208 || myopts="${myopts} NO_SVN_TESTS=YesPlease"
209 use threads \
210 && myopts="${myopts} THREADED_DELTA_SEARCH=YesPlease"
211 use cvs \
212 || myopts="${myopts} NO_CVS=YesPlease"
213 # Disabled until ~m68k-mint can be keyworded again
214 # if [[ ${CHOST} == *-mint* ]] ; then
215 # myopts="${myopts} NO_MMAP=YesPlease"
216 # myopts="${myopts} NO_IPV6=YesPlease"
217 # myopts="${myopts} NO_STRLCPY=YesPlease"
218 # myopts="${myopts} NO_MEMMEM=YesPlease"
219 # myopts="${myopts} NO_MKDTEMP=YesPlease"
220 # myopts="${myopts} NO_MKSTEMPS=YesPlease"
221 # fi
222 if [[ ${CHOST} == ia64-*-hpux* ]]; then
223 myopts="${myopts} NO_NSEC=YesPlease"
224 fi
225 if [[ ${CHOST} == *-*-aix* ]]; then
226 myopts="${myopts} NO_FNMATCH_CASEFOLD=YesPlease"
227 fi
228
229 has_version '>=app-text/asciidoc-8.0' \
230 && myopts="${myopts} ASCIIDOC8=YesPlease"
231 myopts="${myopts} ASCIIDOC_NO_ROFF=YesPlease"
232
233 # Bug 290465:
234 # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
235 [[ "${CHOST}" == *-uclibc* ]] && \
236 myopts="${myopts} NO_NSEC=YesPlease"
237
238 export MY_MAKEOPTS="${myopts}"
239 }
240
241 src_unpack() {
242 if [[ ${PV} != *9999 ]]; then
243 unpack ${MY_P}.tar.${SRC_URI_SUFFIX}
244 cd "${S}"
245 unpack ${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
246 use doc && \
247 cd "${S}"/Documentation && \
248 unpack ${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
249 cd "${S}"
250 else
251 git-2_src_unpack
252 cd "${S}"
253 #cp "${FILESDIR}"/GIT-VERSION-GEN .
254 fi
255
256 }
257
258 src_prepare() {
259 # Noperl is being merged to upstream as of 2009/04/05
260 #epatch "${FILESDIR}"/20090305-git-1.6.2-noperl.patch
261
262 # GetOpt-Long v2.38 is strict
263 # Merged in 1.6.3 final 2009/05/07
264 #epatch "${FILESDIR}"/20090505-git-1.6.2.5-getopt-fixes.patch
265
266 # JS install fixup
267 # Merged in 1.7.5.x
268 #epatch "${FILESDIR}"/git-1.7.2-always-install-js.patch
269
270 # Fix false positives with t3404 due to SHELL=/bin/false for the portage
271 # user.
272 # Merged upstream
273 #epatch "${FILESDIR}"/git-1.7.3.4-avoid-shell-issues.patch
274
275 # bug #350075: t9001: fix missing prereq on some tests
276 # Merged upstream
277 #epatch "${FILESDIR}"/git-1.7.3.4-fix-perl-test-prereq.patch
278
279 # bug #350330 - automagic CVS when we don't want it is bad.
280 epatch "${FILESDIR}"/git-1.7.11.1-optional-cvs.patch
281
282 sed -i \
283 -e 's:^\(CFLAGS =\).*$:\1 $(OPTCFLAGS) -Wall:' \
284 -e 's:^\(LDFLAGS =\).*$:\1 $(OPTLDFLAGS):' \
285 -e 's:^\(CC = \).*$:\1$(OPTCC):' \
286 -e 's:^\(AR = \).*$:\1$(OPTAR):' \
287 -e "s:\(PYTHON_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
288 -e "s:\(PERL_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
289 Makefile || die "sed failed"
290
291 # Never install the private copy of Error.pm (bug #296310)
292 sed -i \
293 -e '/private-Error.pm/s,^,#,' \
294 perl/Makefile.PL
295
296 # Fix docbook2texi command
297 sed -i 's/DOCBOOK2X_TEXI=docbook2x-texi/DOCBOOK2X_TEXI=docbook2texi.pl/' \
298 Documentation/Makefile || die "sed failed"
299
300 # bug #318289
301 # Merged upstream
302 #epatch "${FILESDIR}"/git-1.7.3.2-interix.patch
303
304 # merged upstream
305 #epatch "${FILESDIR}"/git-1.7.5-interix.patch
306
307 # merged upstream
308 #epatch "${FILESDIR}"/git-1.7.6-interix.patch
309
310 # Newer versions of SVN hate a whitespace in the file URL.
311 # So we avoid that by replaced the space with an underscore.
312 #Initialized empty Git repository in /dev/shm/portage/dev-vcs/git-9999/work/git-9999/t/t d.t9155/git_project/.git/
313 #svn: E235000: In file 'subversion/libsvn_subr/dirent_uri.c' line 2291: assertion failed (svn_uri_is_canonical(url, pool))
314 #
315 # With this change the following tests still fail: t9100 t9118 t9120
316 # Without it, MOST of t91* fails, due to the space tripping up the
317 # svn_uri_is_canonical.
318 #
319 # git-svn actually needs to be fixed here, but this chagne is useful for
320 # testing it.
321 #
322 # This patch is my work to date on fixing git-svn, but it causes more
323 # breakage than it fixes (it's manually-edited now to do nothing).
324 #epatch "${FILESDIR}"/git-1.7.8-git-svn-1.7-canonical-path.patch
325 cd "${S}"/t
326 sed -i \
327 -e 's/trash directory/trash_directory/g' \
328 test-lib.sh t0000-basic.sh Makefile || die "sed failed"
329 }
330
331 git_emake() {
332 # bug #326625: PERL_PATH, PERL_MM_OPT
333 # bug #320647: PYTHON_PATH
334 PYTHON_PATH=""
335 use python && PYTHON_PATH="$(PYTHON -a)"
336 emake ${MY_MAKEOPTS} \
337 DESTDIR="${D}" \
338 OPTCFLAGS="${CFLAGS}" \
339 OPTLDFLAGS="${LDFLAGS}" \
340 OPTCC="$(tc-getCC)" \
341 OPTAR="$(tc-getAR)" \
342 prefix="${EPREFIX}"/usr \
343 htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
344 sysconfdir="${EPREFIX}"/etc \
345 PYTHON_PATH="${PYTHON_PATH}" \
346 PERL_MM_OPT="" \
347 GIT_TEST_OPTS="--no-color" \
348 "$@"
349 # This is the fix for bug #326625, but it also causes breakage, see bug
350 # #352693.
351 # PERL_PATH="${EPREFIX}/usr/bin/env perl" \
352 }
353
354 src_configure() {
355 exportmakeopts
356 }
357
358 src_compile() {
359 git_emake || die "emake failed"
360
361 if use emacs ; then
362 elisp-compile contrib/emacs/git{,-blame}.el \
363 || die "emacs modules failed"
364 fi
365
366 if use perl && use cgi ; then
367 git_emake \
368 gitweb/gitweb.cgi \
369 || die "emake gitweb/gitweb.cgi failed"
370 fi
371
372 cd "${S}"/Documentation
373 if [[ ${PV} == *9999 ]] ; then
374 git_emake man \
375 || die "emake man failed"
376 if use doc ; then
377 git_emake info html \
378 || die "emake info html failed"
379 fi
380 else
381 if use doc ; then
382 git_emake info \
383 || die "emake info html failed"
384 fi
385 fi
386 }
387
388 src_install() {
389 git_emake \
390 install || \
391 die "make install failed"
392
393 # Depending on the tarball and manual rebuild of the documentation, the
394 # manpages may exist in either OR both of these directories.
395 find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
396 find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
397
398 dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
399 use doc && dodir /usr/share/doc/${PF}/html
400 for d in / /howto/ /technical/ ; do
401 docinto ${d}
402 dodoc Documentation${d}*.txt
403 use doc && dohtml -p ${d} Documentation${d}*.html
404 done
405 docinto /
406 # Upstream does not ship this pre-built :-(
407 use doc && doinfo Documentation/{git,gitman}.info
408
409 newbashcomp contrib/completion/git-completion.bash ${PN}
410
411 if use emacs ; then
412 elisp-install ${PN} contrib/emacs/git.{el,elc} || die
413 elisp-install ${PN} contrib/emacs/git-blame.{el,elc} || die
414 #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc} || die
415 # don't add automatically to the load-path, so the sitefile
416 # can do a conditional loading
417 touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
418 elisp-site-file-install "${FILESDIR}"/${SITEFILE} || die
419 fi
420
421 if use python && use gtk ; then
422 dobin "${S}"/contrib/gitview/gitview
423 python_convert_shebangs ${PYTHON_ABI} "${ED}"/usr/bin/gitview
424 dodoc "${S}"/contrib/gitview/gitview.txt
425 fi
426
427 #dobin contrib/fast-import/git-p4 # Moved upstream
428 #dodoc contrib/fast-import/git-p4.txt # Moved upstream
429 newbin contrib/fast-import/import-tars.perl import-tars
430 newbin contrib/git-resurrect.sh git-resurrect
431
432 dodir /usr/share/${PN}/contrib
433 # The following are excluded:
434 # completion - installed above
435 # emacs - installed above
436 # examples - these are stuff that is not used in Git anymore actually
437 # gitview - installed above
438 # p4import - excluded because fast-import has a better one
439 # patches - stuff the Git guys made to go upstream to other places
440 # svnimport - use git-svn
441 # thunderbird-patch-inline - fixes thunderbird
442 for i in \
443 blameview buildsystems ciabot continuous convert-objects fast-import \
444 hg-to-git hooks remotes2config.sh remotes2config.sh rerere-train.sh \
445 stats svn-fe vim workdir \
446 ; do
447 cp -rf \
448 "${S}"/contrib/${i} \
449 "${ED}"/usr/share/${PN}/contrib \
450 || die "Failed contrib ${i}"
451 done
452
453 if use perl && use cgi ; then
454 # We used to install in /usr/share/${PN}/gitweb
455 # but upstream installs in /usr/share/gitweb
456 # so we will install a symlink and use their location for compat with other
457 # distros
458 dosym /usr/share/gitweb /usr/share/${PN}/gitweb
459
460 # INSTALL discusses configuration issues, not just installation
461 docinto /
462 newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
463 newdoc "${S}"/gitweb/README README.gitweb
464
465 find "${ED}"/usr/lib64/perl5/ \
466 -name .packlist \
467 -exec rm \{\} \;
468 else
469 rm -rf "${ED}"/usr/share/gitweb
470 fi
471
472 if ! use subversion ; then
473 rm -f "${ED}"/usr/libexec/git-core/git-svn \
474 "${ED}"/usr/share/man/man1/git-svn.1*
475 fi
476
477 if use xinetd ; then
478 insinto /etc/xinetd.d
479 newins "${FILESDIR}"/git-daemon.xinetd git-daemon
480 fi
481
482 newinitd "${FILESDIR}"/git-daemon.initd git-daemon
483 newconfd "${FILESDIR}"/git-daemon.confd git-daemon
484
485 fixlocalpod
486 }
487
488 src_test() {
489 local disabled=""
490 local tests_cvs="t9200-git-cvsexportcommit.sh \
491 t9400-git-cvsserver-server.sh \
492 t9401-git-cvsserver-crlf.sh \
493 t9600-cvsimport.sh \
494 t9601-cvsimport-vendor-branch.sh \
495 t9602-cvsimport-branches-tags.sh \
496 t9603-cvsimport-patchsets.sh"
497 local tests_perl="t5502-quickfetch.sh \
498 t5512-ls-remote.sh \
499 t5520-pull.sh"
500 # Bug #225601 - t0004 is not suitable for root perm
501 # Bug #219839 - t1004 is not suitable for root perm
502 # t0001-init.sh - check for init notices EPERM* fails
503 local tests_nonroot="t0001-init.sh \
504 t0004-unwritable.sh \
505 t0070-fundamental.sh \
506 t1004-read-tree-m-u-wf.sh \
507 t3700-add.sh \
508 t7300-clean.sh"
509 # t9100 t9118 t9120 all fail with SVN 1.7, despite the workaround for spaces
510 # in the test directory.
511 local test_svn="t9100-git-svn-basic.sh \
512 t9118-git-svn-funky-branch-names.sh \
513 t9120-git-svn-clone-with-percent-escapes.sh"
514
515 # Unzip is used only for the testcase code, not by any normal parts of Git.
516 if ! has_version app-arch/unzip ; then
517 einfo "Disabling tar-tree tests"
518 disabled="${disabled} t5000-tar-tree.sh"
519 fi
520
521 cvs=0
522 use cvs && let cvs=$cvs+1
523 if [[ ${EUID} -eq 0 ]]; then
524 if [[ $cvs -eq 1 ]]; then
525 ewarn "Skipping CVS tests because CVS does not work as root!"
526 ewarn "You should retest with FEATURES=userpriv!"
527 disabled="${disabled} ${tests_cvs}"
528 fi
529 einfo "Skipping other tests that require being non-root"
530 disabled="${disabled} ${tests_nonroot}"
531 else
532 [[ $cvs -gt 0 ]] && \
533 has_version dev-vcs/cvs && \
534 let cvs=$cvs+1
535 [[ $cvs -gt 1 ]] && \
536 built_with_use dev-vcs/cvs server && \
537 let cvs=$cvs+1
538 if [[ $cvs -lt 3 ]]; then
539 einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
540 disabled="${disabled} ${tests_cvs}"
541 fi
542 fi
543
544 if ! use perl ; then
545 einfo "Disabling tests that need Perl"
546 disabled="${disabled} ${tests_perl}"
547 fi
548
549 einfo "Disabling tests that fail with SVN 1.7"
550 disabled="${disabled} ${test_svn}"
551
552 # Reset all previously disabled tests
553 cd "${S}/t"
554 for i in *.sh.DISABLED ; do
555 [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
556 done
557 einfo "Disabled tests:"
558 for i in ${disabled} ; do
559 [[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
560 done
561
562 # Avoid the test system removing the results because we want them ourselves
563 sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
564 -i "${S}"/t/Makefile
565
566 # Clean old results first, must always run
567 cd "${S}/t"
568 nonfatal git_emake clean
569
570 # Now run the tests, keep going if we hit an error, and don't terminate on
571 # failure
572 cd "${S}"
573 einfo "Start test run"
574 #MAKEOPTS=-j1
575 nonfatal git_emake --keep-going test
576 rc=$?
577
578 # Display nice results, now print the results
579 cd "${S}/t"
580 nonfatal git_emake aggregate-results
581
582 # And bail if there was a problem
583 [ $rc -eq 0 ] || die "tests failed. Please file a bug."
584 }
585
586 showpkgdeps() {
587 local pkg=$1
588 shift
589 elog " $(printf "%-17s:" ${pkg}) ${@}"
590 }
591
592 pkg_postinst() {
593 use emacs && elisp-site-regen
594 use python && python_mod_optimize git_remote_helpers
595 einfo "Please read /usr/share/bash-completion/git for Git bash completion"
596 elog "These additional scripts need some dependencies:"
597 echo
598 showpkgdeps git-quiltimport "dev-util/quilt"
599 showpkgdeps git-instaweb \
600 "|| ( www-servers/lighttpd www-servers/apache )"
601 echo
602 }
603
604 pkg_postrm() {
605 use emacs && elisp-site-regen
606 use python && python_mod_cleanup git_remote_helpers
607 }